$compile exe

dim curline as string, tblname as string, table as string, vermajor as byte, verminor as byte
dim infile as string, outfile as string, offset as string, strings as string, tables as string
dim offsets as string, x as long, verstr as string
dim sp as long, curi as long, spac as string, entoffs(0 to 16383) as word, entstrs(0 to 16383) as string, crlf as string, debug as byte

shared curi, entoffs(), entstrs(), debug

dim nvar as string 'needed variable

'debug = 1

curi = 0
spac$ = " "
'if debug = 1 then
	'print "Command line: " + command$
        'end if

if len(command$) = 0 then terminateapp "Required parameter missing"

sp = instr(command$, spac$)
if sp = 0 then terminateapp "Required parameter missing"

infile$ = left$(command$, sp - 1)
'infile$ = "WINSETUP.INI"
if len(dir$(infile$)) = 0 then terminateapp "Input file does not exist"
print "Input file: " + infile$
print ""

outfile$ = right$(command$, len(command$) - sp)
'outfile$ = "TEMP$$$$.INI"
print "Output file: " + outfile$
if len(dir$(outfile$)) > 0 then remfile outfile$, "Output file already exists, removing..."
print ""

OPEN infile$ FOR INPUT AS #1
OPEN outfile$ FOR BINARY AS #2
	'let's go
	do
		if eof(1) then exit loop
		line INPUT #1, curline$
		curline$ = extract$(curline$, chr$(13) + chr$(10))
		curline$ = extract$(curline$, ";")
		curline$ = trim$(curline$)

		'we have the line cleaned up so let's read it
		if curline$ = "" then
			'empty line, let's ignore it
		else
			if uleft$(curline$, 11) = "BEGIN TABLE" then
				if len(curline$) < (12 + 1) then goto notheader
				tblname$ = right$(curline$, len(curline$) - 12)
				'now let's get last 12 bytes of the line
				if len(tblname$) < 12 then goto noversion
				verstr$ = right$(tblname$, 12)
				verst$ = uleft$(verstr$, 8)
                                'if debug = 1 then print "verstr$ = " + chr$(34) + verstr$ + chr$(34)
				if verst$ = "VERSION=" then
					'version string found, we need to fix the tblname
					tblname$ = textract$(tblname$, verstr$)
					'now get the version numbers
					verstr$ = right$(verstr$, 4)
					vermajor = lval(verstr$, 1)
					verminor = rval(verstr$, 2)
				end if				
			noversion:
				tables$ = tables$ + padzero$(tblname$) + binver$(vermajor, verminor) + binlen$(offsets$)
			else
				if ucase$(curline$) = "END TABLE" then
					offsets$ = offsets$ + mkwrd$(&hFFFF)
				else
                                notheader:
					x = findinarray(curline$)
					if x = &h10000 then
						'not processed yet
						addtoarray curline$, len(strings$)
						offsets$ = offsets$ + binlen$(strings$)
						strings$ = strings$ + curline$ + chr$(0)
					else
						offsets$ = offsets$ + mkwrd$(entoffs(x))
					end if
				end if
			end if
		end if
	loop

	nvar$ = binlen$(tables$)
	put$ #2, nvar$
	put$ #2, tables$
	nvar$ = binlen$(strings$)
	put$ #2, nvar$
	put$ #2, strings$
	nvar$ = binlen$(offsets$)
	put$ #2, nvar$
	put$ #2, offsets$
close #2
close #1

function binlen(st as string) as string
dim temp as word
	temp = len(st)
	binlen = mkwrd$(temp)
end function

function wordlen(st as string) as word
	wordlen = cword(len(st))
end function

function binver(major as byte, minor as byte) as string
	binver = chr$(major) + chr$(minor)
end function

function findinarray(st as string) as dword
dim i as long
	findinarray = &h10000
	if curi = 0 then exit function
	array scan entstrs() for curi, = st, to i
	if i > 0 then findinarray = i - 1
end function

sub addtoarray(st as string, o as word)
	entstrs(curi) = st
	entoffs(curi) = o
	curi = curi + 1
end sub

function trim(st as string) as string
	trim = ltrim$(rtrim$(st))
end function

function uleft(st as string, size as integer) as string
	uleft = ucase$(left$(st, size))
end function

function lval(st as string, size as integer) as byte
	lval = val(left$(st, size))
end function

function rval(st as string, size as integer) as byte
	rval = val(right$(st, size))
end function

function padzero(st as string) as string
        'if debug = 1 then print "PADZero,  st = " + chr$(34) + st + chr$(34) + ", len(st) = " + ltrim$(str$(len(st)))
	padzero = st + string$(20 - len(st), chr$(0))
end function

function textract(st as string, match as string) as string
	textract = rtrim$(extract$(st, match))
end function

sub terminateapp(errormsg as string)
	print errormsg
	end
end sub

sub remfile(filename as string, warning as string)
	if warning <> "" then print warning
	kill filename
end sub